"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Carousel = _interopRequireWildcard(require("react-native-simple-elements/components/Carousel"));

var _Image = _interopRequireDefault(require("react-native-simple-elements/components/Image/Image"));

var _RatioBox = _interopRequireDefault(require("../RatioBox"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const defaultRenderItem = props => {
  const {
    index
  } = props;
  return /*#__PURE__*/React.createElement(_Image.default, {
    key: index,
    source: {
      uri: "https://via.placeholder.com/350x150"
    },
    style: {
      width: 250,
      height: 150
    }
  });
};

const defaultProps = {
  containerRatio: "16x9",
  data: []
};

const CarouselBanner = props => {
  var _props$renderItem;

  const {
    containerRatio,
    sliderWidth,
    itemWidth,
    data
  } = props;

  const _imageCarouselRef = /*#__PURE__*/React.createRef();

  const [isShowCarousel, setIsShowCarousel] = React.useState(false);
  React.useEffect(() => {
    setTimeout(() => {
      setIsShowCarousel(true);
    }, 150);
  }, []);
  const renderItem = (_props$renderItem = props.renderItem) !== null && _props$renderItem !== void 0 ? _props$renderItem : defaultRenderItem;
  return /*#__PURE__*/React.createElement(_RatioBox.default, {
    ratio: containerRatio
  }, isShowCarousel && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Carousel.LeftArrow, {
    onPress: e => {
      var _imageCarouselRef$cur;

      return (_imageCarouselRef$cur = _imageCarouselRef.current) === null || _imageCarouselRef$cur === void 0 ? void 0 : _imageCarouselRef$cur.snapToPrev();
    }
  }), /*#__PURE__*/React.createElement(_Carousel.default, {
    sliderWidth: sliderWidth,
    itemWidth: itemWidth !== null && itemWidth !== void 0 ? itemWidth : sliderWidth,
    data: data,
    renderItem: ({
      item,
      index
    }) => renderItem({
      item,
      index
    }),
    ref: _imageCarouselRef,
    loop: true
  }), /*#__PURE__*/React.createElement(_Carousel.RightArrow, {
    onPress: e => {
      var _imageCarouselRef$cur2;

      return (_imageCarouselRef$cur2 = _imageCarouselRef.current) === null || _imageCarouselRef$cur2 === void 0 ? void 0 : _imageCarouselRef$cur2.snapToNext();
    }
  })));
};

CarouselBanner.defaultProps = defaultProps;
var _default = CarouselBanner;
exports.default = _default;
//# sourceMappingURL=CarouselBanner.js.map