"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _UITestingHelper = require("../utils/UITestingHelper");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const FieldValidator = props => {
  const {
    fieldComponent: FieldComponent,
    touched,
    values,
    onChange,
    onBlur,
    onFocus,
    isTrim,
    name,
    errors,
    ...restProps
  } = props;
  const error = errors[name] || {};
  React.useEffect(() => {
    if (error.error && error.errorMsg) {// do something
    } // eslint-disable-next-line

  }, [error.error, error.errorMsg]);

  const handleChange = (value, item) => {
    if (isTrim && value) {
      value = value.trim();
    }

    onChange(value, item);
  };

  return /*#__PURE__*/React.createElement(FieldComponent, _extends({
    errorMsg: error.errorMsg,
    value: values[name],
    onChange: handleChange,
    onBlur: onBlur,
    onFocus: onFocus
  }, (0, _UITestingHelper.fullTestProps)("field-validator"), restProps));
};

var _default = FieldValidator;
exports.default = _default;
//# sourceMappingURL=FieldValidator.js.map