"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRandomIntToMax = exports.getRandomIntInclusive = exports.getRandomInt = exports.getRandomArbitrary = void 0;

// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
const getRandomArbitrary = (min, max) => {
  return Math.random() * (max - min) + min;
}; // The minimum is inclusive and the maximum is exclusive


exports.getRandomArbitrary = getRandomArbitrary;

const getRandomInt = (min, max) => {
  const _min = Math.ceil(min);

  const _max = Math.floor(max);

  return Math.floor(Math.random() * (_max - _min) + _min);
}; // The minimum is inclusive and the is maximum inclusive


exports.getRandomInt = getRandomInt;

const getRandomIntInclusive = (min, max) => {
  const _min = Math.ceil(min);

  const _max = Math.floor(max);

  return Math.floor(Math.random() * (_max - _min + 1) + _min);
};

exports.getRandomIntInclusive = getRandomIntInclusive;

const getRandomIntToMax = max => {
  return Math.floor(Math.random() * max);
};

exports.getRandomIntToMax = getRandomIntToMax;
//# sourceMappingURL=index.js.map