import * as React from "react";
import { LocaleProviderCtx } from "./LocaleProvider";

const useTranslation = () => {
  const polyglot = React.useContext(LocaleProviderCtx);

  const translate = (...prop) => {
    return polyglot && polyglot.t(...prop);
  };

  return translate;
};

export default useTranslation;
//# sourceMappingURL=useTranslation.js.map