// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
export const getRandomArbitrary = (min, max) => {
  return Math.random() * (max - min) + min;
}; // The minimum is inclusive and the maximum is exclusive

export const getRandomInt = (min, max) => {
  const _min = Math.ceil(min);

  const _max = Math.floor(max);

  return Math.floor(Math.random() * (_max - _min) + _min);
}; // The minimum is inclusive and the is maximum inclusive

export const getRandomIntInclusive = (min, max) => {
  const _min = Math.ceil(min);

  const _max = Math.floor(max);

  return Math.floor(Math.random() * (_max - _min + 1) + _min);
};
export const getRandomIntToMax = max => {
  return Math.floor(Math.random() * max);
};
//# sourceMappingURL=index.js.map