export const BACKGROUND_COLOR_LIGHT: "white";
export const BACKGROUND_COLOR_DARK: "#0E0E0E";
export const BORDER_COLOR: "#d5d5d5";
export const BORDER_COLOR_DARK: "#272729";
export const BORDER_RADIUS: 13;
export const BUTTON_FONT_WEIGHT: "normal";
export const BUTTON_FONT_COLOR: "#007ff9";
export const BUTTON_FONT_SIZE: 20;
export const HIGHLIGHT_COLOR_DARK: "#444444";
export const HIGHLIGHT_COLOR_LIGHT: "#ebebeb";
export const TITLE_FONT_SIZE: 20;
export const TITLE_COLOR: "#8f8f8f";
export class DateTimePickerModal extends React.PureComponent<any, any, any> {
    static getDerivedStateFromProps(props: any, state: any): {
        currentDate: any;
        isPickerVisible: boolean;
    };
    constructor(...args: any[]);
    didPressConfirm: boolean;
}
export function Header({ label, style }: {
    label: any;
    style?: {
        root: {
            borderBottomColor: string;
            borderBottomWidth: number;
            padding: number;
            backgroundColor: string;
        };
        text: {
            textAlign: "center";
            color: string;
            fontSize: number;
        };
    };
}): React.CElement<import("react-native").ViewProps, View>;
export namespace headerStyles {
    export namespace root {
        export { BORDER_COLOR as borderBottomColor };
        export const borderBottomWidth: number;
        export const padding: number;
        export const backgroundColor: string;
    }
    export namespace text {
        export const textAlign: "center";
        export { TITLE_COLOR as color };
        export { TITLE_FONT_SIZE as fontSize };
    }
}
export function ConfirmButton({ isDarkModeEnabled, onPress, label, style }: {
    isDarkModeEnabled: any;
    onPress: any;
    label: any;
    style?: {
        button: {
            borderTopWidth: number;
            backgroundColor: string;
            height: number;
            justifyContent: "center";
        };
        buttonLight: {
            borderColor: string;
        };
        buttonDark: {
            borderColor: string;
        };
        text: {
            textAlign: "center";
            color: string;
            fontSize: number;
            fontWeight: "normal";
            backgroundColor: string;
        };
    };
}): React.CElement<import("react-native").TouchableHighlightProps, TouchableHighlight>;
export namespace confirmButtonStyles {
    export namespace button {
        export const borderTopWidth: number;
        const backgroundColor_1: string;
        export { backgroundColor_1 as backgroundColor };
        export const height: number;
        export const justifyContent: "center";
    }
    export namespace buttonLight {
        export { BORDER_COLOR as borderColor };
    }
    export namespace buttonDark {
        export { BORDER_COLOR_DARK as borderColor };
    }
    export namespace text_1 {
        const textAlign_1: "center";
        export { textAlign_1 as textAlign };
        export { BUTTON_FONT_COLOR as color };
        export { BUTTON_FONT_SIZE as fontSize };
        export { BUTTON_FONT_WEIGHT as fontWeight };
        const backgroundColor_2: string;
        export { backgroundColor_2 as backgroundColor };
    }
    export { text_1 as text };
}
export function CancelButton({ isDarkModeEnabled, onPress, label, style }: {
    isDarkModeEnabled: any;
    onPress: any;
    label: any;
    style?: {
        button: {
            borderRadius: number;
            height: number;
            marginBottom: number;
            justifyContent: "center";
        };
        buttonLight: {
            backgroundColor: string;
        };
        buttonDark: {
            backgroundColor: string;
        };
        text: {
            padding: number;
            textAlign: "center";
            color: string;
            fontSize: number;
            fontWeight: "600";
            backgroundColor: string;
        };
    };
}): React.CElement<import("react-native").TouchableHighlightProps, TouchableHighlight>;
export namespace cancelButtonStyles {
    export namespace button_1 {
        export { BORDER_RADIUS as borderRadius };
        const height_1: number;
        export { height_1 as height };
        export const marginBottom: number;
        const justifyContent_1: "center";
        export { justifyContent_1 as justifyContent };
    }
    export { button_1 as button };
    export namespace buttonLight_1 {
        export { BACKGROUND_COLOR_LIGHT as backgroundColor };
    }
    export { buttonLight_1 as buttonLight };
    export namespace buttonDark_1 {
        export { BACKGROUND_COLOR_DARK as backgroundColor };
    }
    export { buttonDark_1 as buttonDark };
    export namespace text_2 {
        const padding_1: number;
        export { padding_1 as padding };
        const textAlign_2: "center";
        export { textAlign_2 as textAlign };
        export { BUTTON_FONT_COLOR as color };
        export { BUTTON_FONT_SIZE as fontSize };
        export const fontWeight: "600";
        const backgroundColor_3: string;
        export { backgroundColor_3 as backgroundColor };
    }
    export { text_2 as text };
}
import * as React from "react";
import { View } from "react-native";
import { TouchableHighlight } from "react-native";
